(function() {
  /**
   * 错误捕捉
   */
  // 生产环境：https://collect.pa18.com
  // 测试环境：https://test2-collect.pa18.com:4443

  var isNative = /from:esalesapp/.test(window.navigator.userAgent.toLocaleLowerCase()); // 是否为客户端环境
  var isTestEnv = window.location.origin.indexOf('test') !== -1; // 是否为测试环境
  var isPrd = true;
  var collectUrl = 'https://collect.pa18.com/pss-collect-sender/outer/mq/default/H5CollectError';
  if (isTestEnv || (window.location.href.indexOf('localhost') !== -1)) {
    isPrd = false;
    collectUrl = 'https://test2-collect.pa18.com:4443/pss-collect-sender/outer/mq/default/H5CollectError';
  }

  function postErrorToServer(errorObj) {
    var timeout = 3000;
    var xhr;
    if (window.XMLHttpRequest) {
      xhr = new window.XMLHttpRequest();
    } else {
      xhr = new window.ActiveXObject('Msxml2.XMLHTTP');
    }

    xhr.open('POST', collectUrl, true);
    xhr.setRequestHeader('Content-Type', 'application/json');
    xhr.send(JSON.stringify(errorObj));

    var ptr = setTimeout(() => {
      if (xhr.readyState !== 4) {
        xhr.abort();
      }
    }, timeout);
    xhr.onreadystatechange = () => {
      if (xhr.readyState === 4) {
        clearTimeout(ptr);
        var response = xhr.response;
        if (xhr.status === 200) {
          console.log(response);
        }
      }
    };
  }
  /**
   * 用于检测 vue 错误日志上报。
   * @param {Object}  date           获取错误时间
   * @param {Object}  locationUrl    当前页面
   * @param {String}  projectName    项目名称
   * @param {String}  frameInfo      项目框架 vue || 老版本口袋E项目(jquery)
   * @param {String}  userAgent      浏览器型号
   * @param {Long}    errorMessage   出错信息
   * @param {Object}  errorDesc      错误详细信息，包含错误文件地址，生命周期等
   */
  window.onerror = function(errorMessage, scriptURI, lineNo, columnNo, error) {
    var errorObj = {
      date: new Date().toLocaleString(),
      locationUrl: window.location.href,
      projectName: 'smtsTocms ', // 迁移
      frameInfo: 'jquery',
      userAgent: window.navigator.userAgent.toLocaleLowerCase(),
      errorMessage: errorMessage || null,
      scriptURI: scriptURI || null,
      lineNo: lineNo || null,
      columnNo: columnNo || null,
      errorDesc: error && error.stack ? error.stack : null
    };
    console.log('=====页面错误信息，请查看：========');
    console.log(errorObj);
    if (isNative || isPrd) {
      return postErrorToServer(errorObj);
    }
  }
})();