define([],function(){
	var insuranceUtil = {
			//定义豁免险的险种列表
			 planABC12List : new Array("1101","1102","1103","1117","1124","1295","1125","1147","1148","1170","1184","1185","1297","1224",
					"1101Secd","1102Secd","1103Secd","1117Secd","1124Secd","1295Secd","1125Secd","1147Secd","1148Secd","1170Secd","1184Secd","1185Secd","1224Secd","1247"),
			 planABCList : new Array("834","835","836","839",'1129','1130',"844"),
			 planUIList : new Array("848","860","866","867"),//万能险 todo check
			 planwithoutInsuranceFeeList : new Array("857","854","863","862"),//没有基本保额，需要传yearPremIum字段
			 planUIneedLiveReceSetList : new Array("857","854","863","862"), //需要显示生存金领取的万能险险种
			 add848Plan  : new Array("1155","1187","1188","1128","1128d","1267","1266","1264","1265","1266","1267","1261","1262","1315","1319"),//860会替换848险种,附加860走附加848流程  todo check
			 healthPlan : new Array("557","558","559","560","565"),//健康险
			 annuPlan : new Array("1142","1143"),//年金险
			 //掌上保条款未提供险种
			 clauseNotHasArticle: new Array('1128d','1207','1208','1209','1210','1211','1212','1213','1214','1215','1217','1218','1219','1220','1221','735','74401','854','855','856','857','858','859','860','861','863','1204','1205','559','560','1207_LifeDignity','1209_LifeDignity','1211_LifeDignity','1214_LifeDignity','1217_LifeDignity'),
			 //支持生命尊严的主险列表
			 supportLifeDignityMajorClause : new Array('936','938','996','1126','1113','1178','1180','1207','1211','1209','1217','1214'),
			 //支持生命尊严的主险对应的重疾产品列表
			 supportLifeDignitySicknessClause : new Array('939','941','940','1127','1179','1181','1208','1212','1210','1218','1215'),
			 //支持增加第二被保人的豁免险种列表
			 supportAddSecondInsPlan : new Array('1124','1125','1147','1184','1295'),
			 //支持传承计划的险种
			 supportTrustPlan : new Array('1128','1128d','1187','1188','1267','1268','1265','1262','1315'),
			 //健康告知环节及投保书预览环节问题优化险种
			 supportNewHealthNoticePlan : new Array('1187','1188','1266','1267','1261','1262','1264','1265','1315'),
			 //支持预收流程的险种
			 supportPrePayPlan : new Array('1264','1265','1266','1267','1261','1262'),
			 //是否为固定表头的产品组合
			 FixTableHeaderPlan : new Array('1118','550','840','842','1166'/*,'1142','1143'*/,'1171','1219'),
			 //支持生存金领取年龄/领取比例险种列表
			 receivingSelect : new Array('854','857',"863","862"),
			 //利益演示表头增加聚财宝17和添利宝利益演示表险种列表
			 additionalFormsPlan : new Array('861'),

			//双主险产品 todo check
			 secondMainPlan : new Array('564','866','867','1267','1266','1264','1265','1261','1262','1315','1319'),
			 /**
			  * 判断数组中是否包含某一项
			  * @param arrayList 数组
			  * @param planCode 查找项
			  * @returns {Boolean} 如果包含，返回true，否则返回false
			  */
			 checkWaiverOfPremium : function (arrayList,planCode){
			 	var result = false;
			 	if(arrayList.length == 0){
			 		return false;
			 	}
			 	for(var i = 0 ;i < arrayList.length; i++){
			 		if(arrayList[i] == planCode){
			 			result = true;
			 			break;
			 		}
			 	}
			 	return result;
			 },

			 isPlanABC12 : function(planCode){
				 return this.checkWaiverOfPremium(this.planABC12List, planCode);
			 },

			 isPlanUI : function(planCode){
				 return this.checkWaiverOfPremium(this.planUIList, planCode);
			 },

			 isPlanWithoutInsuranceFee : function(planCode){
				 return this.checkWaiverOfPremium(this.planwithoutInsuranceFeeList, planCode);
			 },
			 isPlanUIneedLiveReceSet : function(planCode){
				 return this.checkWaiverOfPremium(this.planUIneedLiveReceSetList, planCode);
			 },

			 isAdd848Plan : function(planCode){
				 return this.checkWaiverOfPremium(this.add848Plan, planCode);
			 },

			 isAddHealthPlan : function(planCode){
				 return this.checkWaiverOfPremium(this.healthPlan, planCode);
			 },

			 isAnnuPlan : function(planCode){
				return this.checkWaiverOfPremium(this.annuPlan, planCode);
			 },
			 isAddSecondInsPlan : function(planCode){
				 return this.checkWaiverOfPremium(this.supportAddSecondInsPlan, planCode);
			 },
			 isSurpportTrustPlan : function(planCode){
				 return this.checkWaiverOfPremium(this.supportTrustPlan, planCode);
			 },
			 isSupportNewHealthNoticePlan : function(planCode){
				 return this.checkWaiverOfPremium(this.supportNewHealthNoticePlan, planCode);
			 },
			 isSupportPrePayPlan : function(planCode){
				 return this.checkWaiverOfPremium(this.supportPrePayPlan, planCode);
			 },
			 isFixTableHeaderPlan : function(planCode){
				 return this.checkWaiverOfPremium(this.FixTableHeaderPlan, planCode);
			 },
			 isAdditionalFormsPlan : function(addPlanCodeList){
				 var flag = false;
				 for(var i=0;i<addPlanCodeList.length;i++){
					 if(this.checkWaiverOfPremium(this.additionalFormsPlan, addPlanCodeList[i])){
						 flag =  true;
						 break;
					 }
				 }
				 return flag;
			 },
		 accAdd : function(arg1, arg2) {
			    var r1,
			    	r2,
			    	m;
			    try {
			        r1 = arg1.toString().split(".")[1].length
			    } catch(e) {
			        r1 = 0
			    }
			    try {
			        r2 = arg2.toString().split(".")[1].length
			    } catch(e) {
			        r2 = 0
			    }
			    m = Math.pow(10, Math.max(r1, r2))
			    return (arg1 * m + arg2 * m) / m
			},
			 /**
			  * 格式数字为3位加逗号
			  * @param num
			  * @returns {String}
			  */
			 formatNum : function(num){
		        	if(num){
		        		var str=num.toString(), len = str.length, part1 = str, part2 = "";
		        		if (str.indexOf(".") != -1) {
		        			part1 = str.substring(0,str.indexOf("."));
		        			part2 = str.substring(str.indexOf("."),len);
		        		}
		        		var len = part1.length,i=0,returnStr="";
		        		do{
		        			var str2=part1.substring(len,len-1);
		        			len--;
		        			i++;
		        			if(i%3==0&&i<part1.length){
		        				str2=","+str2;
		        			}
		        			returnStr=str2+returnStr;
		        		}while(len>0);
		        		return returnStr+part2;
		        	}else{
		        		return "0";
		        	}
		     },

		     /**
		      * 将数值四舍五入(保留2位小数)后格式化成金额形式
		      *
		      * @param num 数值(Number或者String)
		      * @return 金额格式的字符串,如'1,234,567.45'
		      * @type String
		      */
		      formatCurrency : function(num) {
		         num = num.toString().replace(/\$|\,/g,'');
		         if(isNaN(num))
		         num = "0";
		         sign = (num == (num = Math.abs(num)));
		         num = Math.floor(num*100+0.50000000001);
		         cents = num%100;
		         num = Math.floor(num/100).toString();
		         if(cents<10)
		         cents = "0" + cents;
		         for (var i = 0; i < Math.floor((num.length-(1+i))/3); i++)
		         num = num.substring(0,num.length-(4*i+3))+','+
		         num.substring(num.length-(4*i+3));
		         return (((sign)?'':'-') + num + '.' + cents);
		     },


			 formatNum1 : function(num){
		        	if(num>=10000){
		        		var returnStr=num.toString();
		        		returnStr=returnStr.substring(0,returnStr.length-4);
		        		return returnStr+"万名";
		        	}else{
		        		return "暂无数据";
		        	}
		     },

		     /**
		      * 数值大于等于10000时，四舍五入(保留1位小数)
		      * 数值小于10000时，不做转换
		      *
		      * @param num 数值(Number或者String)
		      * @return 金额格式的字符串,如'1234567.45'
		      * @type String
		      */
		      formatBenefitDesc : function(num) {
		         if(isNaN(num)){
		        	 num = "0元";
		         }else{
			         num = num.toString().replace(/\$|\,/g,'');
			         if(Number(num)>=10000){
			        	 if(Number(num)%10000 == 0){
			        		 num = (Number(num)/10000).toFixed(0) + "万元";
			        	 }else{
			        		 num = (Number(num)/10000).toFixed(1) + "万元";
			        	 }
			         }else{
			        	 if(num.indexOf(".") != -1){
			        		 num = (Number(num)).toFixed(2)+"元";
			        	 }else{
			        		 num+="元";
			        	 }
			         }
		         }
		         return num;
		     },

	     	/**
	         * 该产品是否已有条款页面
	         * @param planCode
	         * @returns {Boolean}
	         */
	        hasClauseArticle : function(planCode){
	        	var self = this;
	        	for(var i=0; i<self.clauseNotHasArticle.length; i++){
	        		if(self.clauseNotHasArticle[i]==planCode){
	        			return false;
	        		}
	        	}
	        	return true;
	        },

	        /**
	         * 该产品是否有生命尊严
	         * @param planCode
	         * @param planInfoList
	         * @returns {Boolean}
	         */
	        hasLifeDignityClause : function(planCode, planInfoList){
	        	var self = this;
	        	for(var i=0; i<self.supportLifeDignityMajorClause.length; i++){
	        		if(self.supportLifeDignityMajorClause[i]==planCode){ //支持生命尊严的主险
	        			if(planInfoList){ //有附险
	        				for(var j=0; j<planInfoList.length; j++){
	        					for(var k=0; k<self.supportLifeDignitySicknessClause.length; k++){
	        						if(self.supportLifeDignitySicknessClause[k]==planInfoList[j].planCode){ //有重疾
	        							return false; //无生命尊严
	        						}
	        					}
	        				}
	        			}
	        			//无附险 或 有附险但无重疾，则有生命尊严
	        			return true;
	        		}
	        	}
	        	return false;//正常产品均无生命尊严

	        },

	        isSecondMainPlan : function(planCode){
	        	return this.checkWaiverOfPremium(this.secondMainPlan, planCode);

	        },
	        565bedata:[{
				"POL_YEAR": 1,
				"PERIOD_INS_FEE": "1893",
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
			    "ANNUAL_PREM": "1969"
			}, {
				"POL_YEAR": 2,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2045"
			}, {
				"POL_YEAR": 3,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2122"
			}, {
				"POL_YEAR": 4,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2199"
			}, {
				"POL_YEAR": 5,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2297"
			}, {
				"POL_YEAR": 6,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2374"
			}, {
				"POL_YEAR": 7,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2451"
			}, {
				"POL_YEAR": 8,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2527"
			}, {
				"POL_YEAR": 9,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2582"
			}, {
				"POL_YEAR": 10,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2627"
			}, {
				"POL_YEAR": 11,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2677"
			}, {
				"POL_YEAR": 12,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2751"
			}, {
				"POL_YEAR": 13,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2787"
			}, {
				"POL_YEAR": 14,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2848"
			}, {
				"POL_YEAR": 15,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "2934"
			}, {
				"POL_YEAR": 16,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "3020"
			}, {
				"POL_YEAR": 17,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "3107"
			}, {
				"POL_YEAR": 18,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "3215"
			}, {
				"POL_YEAR": 19,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "3324"
			}, {
				"POL_YEAR": 20,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "3470"
			}, {
				"POL_YEAR": 21,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "3578"
			}, {
				"POL_YEAR": 22,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "3686"
			}, {
				"POL_YEAR": 23,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "3873"
			}, {
				"POL_YEAR": 24,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "4065"
			}, {
				"POL_YEAR": 25,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "4454"
			}, {
				"POL_YEAR": 26,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "4616"
			}, {
				"POL_YEAR": 27,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "4779"
			}, {
				"POL_YEAR": 28,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "4940"
			}, {
				"POL_YEAR": 29,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "5102"
			}, {
				"POL_YEAR": 30,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "5503"
			}, {
				"POL_YEAR": 31,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "5992"
			}, {
				"POL_YEAR": 32,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "6452"
			}, {
				"POL_YEAR": 33,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "7016"
			}, {
				"POL_YEAR": 34,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "7578"
			}, {
				"POL_YEAR": 35,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "8296"
			}, {
				"POL_YEAR": 36,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "8797"
			}, {
				"POL_YEAR": 37,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "9359"
			}, {
				"POL_YEAR": 38,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "9889"
			}, {
				"POL_YEAR": 39,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "10418"
			}, {
				"POL_YEAR": 40,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "11143"
			}, {
				"POL_YEAR": 41,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "11673"
			}, {
				"POL_YEAR": 42,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "12202"
			}, {
				"POL_YEAR": 43,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "12889"
			}, {
				"POL_YEAR": 44,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "13577"
			}, {
				"POL_YEAR": 45,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "14505"
			}, {
				"POL_YEAR": 46,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "15192"
			}, {
				"POL_YEAR": 47,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "15993"
			}, {
				"POL_YEAR": 48,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "16453"
			}, {
				"POL_YEAR": 49,
				"PERIOD_INS_FEE": 0,
				"ACC_INS_FEE": "1893",
				"RENEWAL_PREM": "1969",
				"ANNUAL_PREM": "17024"
			}],

	};
	return insuranceUtil;
});
