package com.paic.hyperion.core.hfcache.bean;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;
import java.util.ArrayList;
import java.util.List;

public final class CacheManifest$$JsonObjectMapper extends JsonMapper<CacheManifest> {
  @Override
  public CacheManifest parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static CacheManifest _parse(JsonParser jsonParser) throws IOException {
    CacheManifest instance = new CacheManifest();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(CacheManifest instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("appId".equals(fieldName)) {
      instance.appId = jsonParser.getValueAsString(null);
    } else if ("appVersion".equals(fieldName)) {
      instance.appVersion = jsonParser.getValueAsString(null);
    } else if ("plugins".equals(fieldName)) {
      if (jsonParser.getCurrentToken() == JsonToken.START_ARRAY) {
        ArrayList<CachePlugin> collection1 = new ArrayList<CachePlugin>();
        while (jsonParser.nextToken() != JsonToken.END_ARRAY) {
          CachePlugin value1;
          value1 = CachePlugin$$JsonObjectMapper._parse(jsonParser);
          if (value1 != null) {
            collection1.add(value1);
          }
        }
        instance.plugins = collection1;
      } else {
        instance.plugins = null;
      }
    } else if ("resultCode".equals(fieldName)) {
      instance.resultCode = jsonParser.getValueAsInt();
    }
  }

  @Override
  public void serialize(CacheManifest object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(CacheManifest object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("appId", object.appId);
    jsonGenerator.writeStringField("appVersion", object.appVersion);
    final List<CachePlugin> lslocalplugins = object.plugins;
    if (lslocalplugins != null) {
      jsonGenerator.writeFieldName("plugins");
      jsonGenerator.writeStartArray();
      for (CachePlugin element1 : lslocalplugins) {
        if (element1 != null) {
          CachePlugin$$JsonObjectMapper._serialize(element1, jsonGenerator, true);
        }
      }
      jsonGenerator.writeEndArray();
    }
    jsonGenerator.writeNumberField("resultCode", object.resultCode);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
