package com.paic.hyperion.core.hfcache.bean;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;
import java.util.ArrayList;
import java.util.List;

public final class CachePlugin$$JsonObjectMapper extends JsonMapper<CachePlugin> {
  @Override
  public CachePlugin parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static CachePlugin _parse(JsonParser jsonParser) throws IOException {
    CachePlugin instance = new CachePlugin();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(CachePlugin instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("checksum".equals(fieldName)) {
      instance.checksum = jsonParser.getValueAsString(null);
    } else if ("configs".equals(fieldName)) {
      instance.configs = PluginConfig$$JsonObjectMapper._parse(jsonParser);
    } else if ("description".equals(fieldName)) {
      instance.description = jsonParser.getValueAsString(null);
    } else if ("downloadURL".equals(fieldName)) {
      instance.downloadURL = jsonParser.getValueAsString(null);
    } else if ("files".equals(fieldName)) {
      if (jsonParser.getCurrentToken() == JsonToken.START_ARRAY) {
        ArrayList<CacheFile> collection1 = new ArrayList<CacheFile>();
        while (jsonParser.nextToken() != JsonToken.END_ARRAY) {
          CacheFile value1;
          value1 = CacheFile$$JsonObjectMapper._parse(jsonParser);
          if (value1 != null) {
            collection1.add(value1);
          }
        }
        instance.files = collection1;
      } else {
        instance.files = null;
      }
    } else if ("id".equals(fieldName)) {
      instance.id = jsonParser.getValueAsString(null);
    } else if ("increment".equals(fieldName)) {
      instance.increment = jsonParser.getValueAsBoolean();
    } else if ("loadDirect".equals(fieldName)) {
      instance.loadDirect = jsonParser.getValueAsBoolean();
    } else if ("priority".equals(fieldName)) {
      instance.priority = jsonParser.getValueAsInt();
    } else if ("remark".equals(fieldName)) {
      instance.remark = jsonParser.getValueAsString(null);
    } else if ("resultCode".equals(fieldName)) {
      instance.resultCode = jsonParser.getValueAsInt();
    } else if ("size".equals(fieldName)) {
      instance.size = jsonParser.getValueAsLong();
    } else if ("status".equals(fieldName)) {
      instance.status = jsonParser.getValueAsInt();
    } else if ("version".equals(fieldName)) {
      instance.version = jsonParser.getValueAsString(null);
    }
  }

  @Override
  public void serialize(CachePlugin object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(CachePlugin object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("checksum", object.checksum);
    if (object.configs != null) {
      jsonGenerator.writeFieldName("configs");
      PluginConfig$$JsonObjectMapper._serialize(object.configs, jsonGenerator, true);
    }
    jsonGenerator.writeStringField("description", object.description);
    jsonGenerator.writeStringField("downloadURL", object.downloadURL);
    final List<CacheFile> lslocalfiles = object.files;
    if (lslocalfiles != null) {
      jsonGenerator.writeFieldName("files");
      jsonGenerator.writeStartArray();
      for (CacheFile element1 : lslocalfiles) {
        if (element1 != null) {
          CacheFile$$JsonObjectMapper._serialize(element1, jsonGenerator, true);
        }
      }
      jsonGenerator.writeEndArray();
    }
    jsonGenerator.writeStringField("id", object.id);
    jsonGenerator.writeBooleanField("increment", object.increment);
    jsonGenerator.writeBooleanField("loadDirect", object.loadDirect);
    jsonGenerator.writeNumberField("priority", object.priority);
    jsonGenerator.writeStringField("remark", object.remark);
    jsonGenerator.writeNumberField("resultCode", object.resultCode);
    jsonGenerator.writeNumberField("size", object.size);
    jsonGenerator.writeNumberField("status", object.status);
    jsonGenerator.writeStringField("version", object.version);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
