package com.paic.hyperion.core.hfcache.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;
import java.util.ArrayList;
import java.util.List;

public final class FetchManifest$$JsonObjectMapper extends JsonMapper<FetchManifest> {
  @Override
  public FetchManifest parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static FetchManifest _parse(JsonParser jsonParser) throws IOException {
    FetchManifest instance = new FetchManifest();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(FetchManifest instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("appId".equals(fieldName)) {
      instance.appId = jsonParser.getValueAsString(null);
    } else if ("appVersion".equals(fieldName)) {
      instance.appVersion = jsonParser.getValueAsString(null);
    } else if ("extraInfo".equals(fieldName)) {
      instance.extraInfo = ExtraInfo$$JsonObjectMapper._parse(jsonParser);
    } else if ("plugins".equals(fieldName)) {
      if (jsonParser.getCurrentToken() == JsonToken.START_ARRAY) {
        ArrayList<FetchManifestPlugin> collection1 = new ArrayList<FetchManifestPlugin>();
        while (jsonParser.nextToken() != JsonToken.END_ARRAY) {
          FetchManifestPlugin value1;
          value1 = FetchManifestPlugin$$JsonObjectMapper._parse(jsonParser);
          if (value1 != null) {
            collection1.add(value1);
          }
        }
        instance.plugins = collection1;
      } else {
        instance.plugins = null;
      }
    } else if ("requestId".equals(fieldName)) {
      instance.requestId = jsonParser.getValueAsString(null);
    }
  }

  @Override
  public void serialize(FetchManifest object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(FetchManifest object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("appId", object.appId);
    jsonGenerator.writeStringField("appVersion", object.appVersion);
    if (object.extraInfo != null) {
      jsonGenerator.writeFieldName("extraInfo");
      ExtraInfo$$JsonObjectMapper._serialize(object.extraInfo, jsonGenerator, true);
    }
    final List<FetchManifestPlugin> lslocalplugins = object.plugins;
    if (lslocalplugins != null) {
      jsonGenerator.writeFieldName("plugins");
      jsonGenerator.writeStartArray();
      for (FetchManifestPlugin element1 : lslocalplugins) {
        if (element1 != null) {
          FetchManifestPlugin$$JsonObjectMapper._serialize(element1, jsonGenerator, true);
        }
      }
      jsonGenerator.writeEndArray();
    }
    jsonGenerator.writeStringField("requestId", object.requestId);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
