package com.paic.hyperion.core.hfcache.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;
import java.util.ArrayList;
import java.util.List;

public final class Manifest$$JsonObjectMapper extends JsonMapper<Manifest> {
  @Override
  public Manifest parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static Manifest _parse(JsonParser jsonParser) throws IOException {
    Manifest instance = new Manifest();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(Manifest instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("appId".equals(fieldName)) {
      instance.appId = jsonParser.getValueAsString(null);
    } else if ("appVersion".equals(fieldName)) {
      instance.appVersion = jsonParser.getValueAsString(null);
    } else if ("data".equals(fieldName)) {
      if (jsonParser.getCurrentToken() == JsonToken.START_ARRAY) {
        ArrayList<ManifestPlugin> collection1 = new ArrayList<ManifestPlugin>();
        while (jsonParser.nextToken() != JsonToken.END_ARRAY) {
          ManifestPlugin value1;
          value1 = ManifestPlugin$$JsonObjectMapper._parse(jsonParser);
          if (value1 != null) {
            collection1.add(value1);
          }
        }
        instance.data = collection1;
      } else {
        instance.data = null;
      }
    } else if ("requestId".equals(fieldName)) {
      instance.requestId = jsonParser.getValueAsString(null);
    } else if ("resultCode".equals(fieldName)) {
      instance.resultCode = jsonParser.getValueAsInt();
    }
  }

  @Override
  public void serialize(Manifest object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(Manifest object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("appId", object.appId);
    jsonGenerator.writeStringField("appVersion", object.appVersion);
    final List<ManifestPlugin> lslocaldata = object.data;
    if (lslocaldata != null) {
      jsonGenerator.writeFieldName("data");
      jsonGenerator.writeStartArray();
      for (ManifestPlugin element1 : lslocaldata) {
        if (element1 != null) {
          ManifestPlugin$$JsonObjectMapper._serialize(element1, jsonGenerator, true);
        }
      }
      jsonGenerator.writeEndArray();
    }
    jsonGenerator.writeStringField("requestId", object.requestId);
    jsonGenerator.writeNumberField("resultCode", object.resultCode);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
