package com.paic.hyperion.core.hfcache.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;
import java.util.ArrayList;
import java.util.List;

public final class ManifestFile$$JsonObjectMapper extends JsonMapper<ManifestFile> {
  @Override
  public ManifestFile parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static ManifestFile _parse(JsonParser jsonParser) throws IOException {
    ManifestFile instance = new ManifestFile();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(ManifestFile instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("checksum".equals(fieldName)) {
      instance.checksum = jsonParser.getValueAsString(null);
    } else if ("children".equals(fieldName)) {
      if (jsonParser.getCurrentToken() == JsonToken.START_ARRAY) {
        ArrayList<ManifestFile> collection1 = new ArrayList<ManifestFile>();
        while (jsonParser.nextToken() != JsonToken.END_ARRAY) {
          ManifestFile value1;
          value1 = ManifestFile$$JsonObjectMapper._parse(jsonParser);
          if (value1 != null) {
            collection1.add(value1);
          }
        }
        instance.children = collection1;
      } else {
        instance.children = null;
      }
    } else if ("encrypted".equals(fieldName)) {
      instance.encrypted = jsonParser.getValueAsBoolean();
    } else if ("name".equals(fieldName)) {
      instance.name = jsonParser.getValueAsString(null);
    }
  }

  @Override
  public void serialize(ManifestFile object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(ManifestFile object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("checksum", object.checksum);
    final List<ManifestFile> lslocalchildren = object.children;
    if (lslocalchildren != null) {
      jsonGenerator.writeFieldName("children");
      jsonGenerator.writeStartArray();
      for (ManifestFile element1 : lslocalchildren) {
        if (element1 != null) {
          ManifestFile$$JsonObjectMapper._serialize(element1, jsonGenerator, true);
        }
      }
      jsonGenerator.writeEndArray();
    }
    jsonGenerator.writeBooleanField("encrypted", object.encrypted);
    jsonGenerator.writeStringField("name", object.name);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
