package com.paic.hyperion.core.hfcache.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;
import java.util.ArrayList;
import java.util.List;

public final class ManifestPluginDetail$$JsonObjectMapper extends JsonMapper<ManifestPluginDetail> {
  @Override
  public ManifestPluginDetail parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static ManifestPluginDetail _parse(JsonParser jsonParser) throws IOException {
    ManifestPluginDetail instance = new ManifestPluginDetail();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(ManifestPluginDetail instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("content".equals(fieldName)) {
      if (jsonParser.getCurrentToken() == JsonToken.START_ARRAY) {
        ArrayList<ManifestFile> collection1 = new ArrayList<ManifestFile>();
        while (jsonParser.nextToken() != JsonToken.END_ARRAY) {
          ManifestFile value1;
          value1 = ManifestFile$$JsonObjectMapper._parse(jsonParser);
          if (value1 != null) {
            collection1.add(value1);
          }
        }
        instance.content = collection1;
      } else {
        instance.content = null;
      }
    } else if ("description".equals(fieldName)) {
      instance.description = jsonParser.getValueAsString(null);
    } else if ("files".equals(fieldName)) {
      if (jsonParser.getCurrentToken() == JsonToken.START_ARRAY) {
        ArrayList<ManifestPluginZipFile> collection1 = new ArrayList<ManifestPluginZipFile>();
        while (jsonParser.nextToken() != JsonToken.END_ARRAY) {
          ManifestPluginZipFile value1;
          value1 = ManifestPluginZipFile$$JsonObjectMapper._parse(jsonParser);
          if (value1 != null) {
            collection1.add(value1);
          }
        }
        instance.files = collection1;
      } else {
        instance.files = null;
      }
    } else if ("incremental".equals(fieldName)) {
      instance.incremental = jsonParser.getValueAsBoolean();
    } else if ("loadDirect".equals(fieldName)) {
      instance.loadDirect = jsonParser.getValueAsBoolean();
    } else if ("priority".equals(fieldName)) {
      instance.priority = jsonParser.getValueAsInt();
    } else if ("size".equals(fieldName)) {
      instance.size = jsonParser.getValueAsLong();
    }
  }

  @Override
  public void serialize(ManifestPluginDetail object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(ManifestPluginDetail object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    final List<ManifestFile> lslocalcontent = object.content;
    if (lslocalcontent != null) {
      jsonGenerator.writeFieldName("content");
      jsonGenerator.writeStartArray();
      for (ManifestFile element1 : lslocalcontent) {
        if (element1 != null) {
          ManifestFile$$JsonObjectMapper._serialize(element1, jsonGenerator, true);
        }
      }
      jsonGenerator.writeEndArray();
    }
    jsonGenerator.writeStringField("description", object.description);
    final List<ManifestPluginZipFile> lslocalfiles = object.files;
    if (lslocalfiles != null) {
      jsonGenerator.writeFieldName("files");
      jsonGenerator.writeStartArray();
      for (ManifestPluginZipFile element1 : lslocalfiles) {
        if (element1 != null) {
          ManifestPluginZipFile$$JsonObjectMapper._serialize(element1, jsonGenerator, true);
        }
      }
      jsonGenerator.writeEndArray();
    }
    jsonGenerator.writeBooleanField("incremental", object.incremental);
    jsonGenerator.writeBooleanField("loadDirect", object.loadDirect);
    jsonGenerator.writeNumberField("priority", object.priority);
    jsonGenerator.writeNumberField("size", object.size);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
