/*
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS 180-1
 * Version 2.2 Copyright Paul Johnston 2000 - 2009.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for details.
 */

function hex_sha1(r){return rstr2hex(rstr_sha1(str2rstr_utf8(r)))}function b64_sha1(r){return rstr2b64(rstr_sha1(str2rstr_utf8(r)))}function any_sha1(r,t){return rstr2any(rstr_sha1(str2rstr_utf8(r)),t)}function hex_hmac_sha1(r,t){return rstr2hex(rstr_hmac_sha1(str2rstr_utf8(r),str2rstr_utf8(t)))}function b64_hmac_sha1(r,t){return rstr2b64(rstr_hmac_sha1(str2rstr_utf8(r),str2rstr_utf8(t)))}function any_hmac_sha1(r,t,a){return rstr2any(rstr_hmac_sha1(str2rstr_utf8(r),str2rstr_utf8(t)),a)}function sha1_vm_test(){return"a9993e364706816aba3e25717850c26c9cd0d89d"==hex_sha1("abc").toLowerCase()}function rstr_sha1(r){return binb2rstr(binb_sha1(rstr2binb(r),8*r.length))}function rstr_hmac_sha1(r,t){var a=rstr2binb(r);a.length>16&&(a=binb_sha1(a,8*r.length));for(var n=Array(16),e=Array(16),h=0;h<16;h++){cd44bf3750501c57fa3b57729711adee67d9c0;n[h]=909522486^a[h];e[h]=1549556828^a[h]}var s=binb_sha1(n.concat(rstr2binb(t)),512+8*t.length);return binb2rstr(binb_sha1(e.concat(s),672))}function rstr2hex(r){try{}catch(r){hexcase=0}for(var t,a=hexcase?"0123456789ABCDEF":"0123456789abcdef",n="",e=0;e<r.length;e++){t=r.charCodeAt(e);n+=a.charAt(t>>>4&15)+a.charAt(15&t)}return n}function rstr2b64(r){try{}catch(r){b64pad=""}for(var t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="",n=r.length,e=0;e<n;e+=3)for(var h=r.charCodeAt(e)<<16|(e+1<n?r.charCodeAt(e+1)<<8:0)|(e+2<n?r.charCodeAt(e+2):0),s=0;s<4;s++)a+=8*e+6*s>8*r.length?b64pad:t.charAt(h>>>6*(3-s)&63);return a}function rstr2any(r,t){var a,n,e,h,s=t.length,o=Array(),f=Array(Math.ceil(r.length/2));for(a=0;a<f.length;a++)f[a]=r.charCodeAt(2*a)<<8|r.charCodeAt(2*a+1);for(;f.length>0;){h=Array();e=0;for(a=0;a<f.length;a++){e=(e<<16)+f[a];n=Math.floor(e/s);e-=n*s;(h.length>0||n>0)&&(h[h.length]=n)}o[o.length]=e;f=h}var c="";for(a=o.length-1;a>=0;a--)c+=t.charAt(o[a]);var _=Math.ceil(8*r.length/(Math.log(t.length)/Math.log(2)));for(a=c.length;a<_;a++)c=t[0]+c;return c}function str2rstr_utf8(r){for(var t,a,n="",e=-1;++e<r.length;){t=r.charCodeAt(e);a=e+1<r.length?r.charCodeAt(e+1):0;if(55296<=t&&t<=56319&&56320<=a&&a<=57343){t=65536+((1023&t)<<10)+(1023&a);e++}t<=127?n+=String.fromCharCode(t):t<=2047?n+=String.fromCharCode(192|t>>>6&31,128|63&t):t<=65535?n+=String.fromCharCode(224|t>>>12&15,128|t>>>6&63,128|63&t):t<=2097151&&(n+=String.fromCharCode(240|t>>>18&7,128|t>>>12&63,128|t>>>6&63,128|63&t))}return n}function str2rstr_utf16le(r){for(var t="",a=0;a<r.length;a++)t+=String.fromCharCode(255&r.charCodeAt(a),r.charCodeAt(a)>>>8&255);return t}function str2rstr_utf16be(r){for(var t="",a=0;a<r.length;a++)t+=String.fromCharCode(r.charCodeAt(a)>>>8&255,255&r.charCodeAt(a));return t}function rstr2binb(r){for(var t=Array(r.length>>2),a=0;a<t.length;a++)t[a]=0;for(var a=0;a<8*r.length;a+=8)t[a>>5]|=(255&r.charCodeAt(a/8))<<24-a%32;return t}function binb2rstr(r){for(var t="",a=0;a<32*r.length;a+=8)t+=String.fromCharCode(r[a>>5]>>>24-a%32&255);return t}function binb_sha1(r,t){r[t>>5]|=128<<24-t%32;r[(t+64>>9<<4)+15]=t;for(var a=Array(80),n=1732584193,e=-271733879,h=-1732584194,s=271733878,o=-1009589776,f=0;f<r.length;f+=16){for(var c=n,_=e,u=h,d=s,i=o,b=0;b<80;b++){b<16?a[b]=r[f+b]:a[b]=bit_rol(a[b-3]^a[b-8]^a[b-14]^a[b-16],1);var l=safe_add(safe_add(bit_rol(n,5),sha1_ft(b,e,h,s)),safe_add(safe_add(o,a[b]),sha1_kt(b)));o=s;s=h;h=bit_rol(e,30);e=n;n=l}n=safe_add(n,c);e=safe_add(e,_);h=safe_add(h,u);s=safe_add(s,d);o=safe_add(o,i)}return Array(n,e,h,s,o)}function sha1_ft(r,t,a,n){return r<20?t&a|~t&n:r<40?t^a^n:r<60?t&a|t&n|a&n:t^a^n}function sha1_kt(r){return r<20?1518500249:r<40?1859775393:r<60?-1894007588:-899497514}function safe_add(r,t){var a=(65535&r)+(65535&t),n=(r>>16)+(t>>16)+(a>>16);return n<<16|65535&a}function bit_rol(r,t){return r<<t|r>>>32-t}var hexcase=0,b64pad="";